#!/usr/bin/env python

#defines

n_logfile = "~/.smartdj.log" # FIXME configurable
n_config = "~/.smartdj.conf"
n_fifo = "~/.smartdj.m3ufifo"

n_create_sql = "CREATE TABLE analysis (  url varchar(255) NOT NULL default '',  volume_diff float default NULL,  freq0 float default NULL,  freq1 float default NULL,  freq2 float default NULL,  freq3 float default NULL,  freq4 float default NULL,  freq5 float default NULL,  freq6 float default NULL,  freq7 float default NULL,  freq8 float default NULL,  freq9 float default NULL,  freq10 float default NULL,  freq11 float default NULL,  freq12 float default NULL,  freq13 float default NULL,  freq14 float default NULL,  freq15 float default NULL,  freq16 float default NULL,  freq17 float default NULL,  freq18 float default NULL,  freq19 float default NULL,  freq20 float default NULL,  freq21 float default NULL,  freq22 float default NULL,  freq23 float default NULL,  freq24 float default NULL,  freq25 float default NULL,  freq26 float default NULL,  freq27 float default NULL,  freq28 float default NULL,  freq29 float default NULL,  bpm float default NULL,  interface_used varchar(4) NOT NULL default '',  PRIMARY KEY  (url) );"

n_date_analyzed = "user.songanalysis.dateAnalyzed" # a number which should be the stat() mtime entry
n_tempo = "user.songanalysis.tempo" # a number, expressed in python str(float(x)) format.  if nil, or inf or -inf, it should NOT BE STORED
n_songanalysis_interface = "user.songanalysis.interfaceVersion" # a number determining the interface version
n_freqbands = "user.songanalysis.frequencyBands" # a series of float numbers separated by commas.  if not available, it should NOT BE STORED
n_voldiff = "user.songanalysis.volumeDifference" # a float number.  if not available, it should NOT BE STORED


SONG_IM_LISTENING = 1 # works both for 'based on' and 'after'
LAST_SONG_IN_PLAYLIST = 2
SONG_IM_LISTENING_WANDER = 3 # works both for 'based on' and 'after'
LAST_SONG_I_LIKED = 4 # works both for 'based on' and 'after'

FIXED_TEMPO = 1
CHOSEN_SONG_TEMPO = 2

#end defines

class NoChoicesFound(Exception): pass

# utility commands, used in emergency situations, with nearly zero dependencies

import os
from AsyncProcess import AsyncProcess

def run(command,*args):
	arguments = [ command ]
	for a in args: arguments.append(a)
	return os.spawnlp(os.P_WAIT,command,*arguments)

def say_sorry(errmsg):
	if run("kdialog","--error",errmsg) != 0: run("xmessage",errmsg)

def passive_popup(message,title="Smart DJ",timeout=5):
	assert(type(title) is str)
	AsyncProcess(target=run,args=('kdialog','--title',title,'--passivepopup',message,str(timeout))).start()

# end emergency utility commands


import locale
def tounicode(string):
	if string is None: return None
	return unicode(string,locale.getpreferredencoding())
